/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.checkresult;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;

@XmlAccessorType(XmlAccessType.FIELD)
public class ErrorDetails {

	@XmlElement(name = "polygon", required = false)
	private List<PolygonReport> polygon;
	
	@XmlElement(name = "ring", required = false)
	private List<RingReport> ring;

	@XmlElement(name = "geometry", required = false)
	private List<GeometryReport> geometry;

	@XmlElement(name = "vertex", required = false)
	private List<VertexReport> vertex;

	@XmlElement(name = "edge", required = false)
	private List<EdgeReport> edge;

	@XmlElement(name = "parameter", required = false)
	private List<ParameterReport> parameter;

	@XmlElement(name = "polygons", required = false)
	private List<PolygonsReport> polygons;

	@XmlElement(name = "edges", required = false)
	private List<EdgesReport> edges;

	@XmlElement(name = "surface", required = false)
	private List<SurfaceReport> surface;

	public void setEdge(List<EdgeReport> edge) {
		this.edge = edge;
	}
	
	public void setRing(List<RingReport> ring) {
		this.ring = ring;
	}

	public void setEdges(List<EdgesReport> edges) {
		this.edges = edges;
	}

	public void setGeometry(List<GeometryReport> geometry) {
		this.geometry = geometry;
	}
	
	public void setParameter(List<ParameterReport> parameter) {
		this.parameter = parameter;
	}
	
	public void setPolygon(List<PolygonReport> polygon) {
		this.polygon = polygon;
	}
	
	public void setPolygons(List<PolygonsReport> polygons) {
		this.polygons = polygons;
	}
	
	public void setSurface(List<SurfaceReport> surface) {
		this.surface = surface;
	}
	
	public void setVertex(List<VertexReport> vertex) {
		this.vertex = vertex;
	}
	
	public List<RingReport> getRing() {
		if (ring == null) {
			ring = new ArrayList<>();
		}
		return ring;
	}
	
	public List<EdgeReport> getEdge() {
		if (edge == null) {
			edge = new ArrayList<>();
		}
		return edge;
	}
	
	public List<EdgesReport> getEdges() {
		if (edges == null) {
			edges = new ArrayList<>();
		}
		return edges;
	}
	
	public List<GeometryReport> getGeometry() {
		if (geometry == null) {
			geometry = new ArrayList<>();
		}
		return geometry;
	}
	
	public List<ParameterReport> getParameter() {
		if (parameter == null) {
			parameter = new ArrayList<>();
		}
		return parameter;
	}
	
	public List<PolygonReport> getPolygon() {
		if (polygon == null) {
			polygon = new ArrayList<>();
		}
		return polygon;
	}
	
	public List<PolygonsReport> getPolygons() {
		if (polygons == null) {
			polygons = new ArrayList<>();
		}
		return polygons;
	}
	
	public List<SurfaceReport> getSurface() {
		if (surface == null) {
			surface = new ArrayList<>();
		}
		return surface;
	}
	
	public List<VertexReport> getVertex() {
		if (vertex == null) {
			vertex = new ArrayList<>();
		}
		return vertex;
	}

}
